/*******************************************************************************
*                                                                              *
* This is a test-bench for the Serial I/F of SiTCP                             *
*                                                                              *
* System      : SiTCP                                                          *
* Version     : v 0.0.0 2008/03/26 17:21                                       *
*                                                                              *
* Designer    : Tomohisa Uchida                                                *
*                                                                              *
*                Copyright (c) 2008 Tomohisa Uchida                            *
*                All rights reserved                                           *
*                                                                              *
*******************************************************************************/
`timescale 1ns/1ns

`include "SIO_MASTER.v"
`include "SIO_SLAVE.v"
`include "SIO_REG.v"

module SIO_TB;
	wire			DLY_CLK			;
	reg				resetSw			;
	reg				LOC_ACT		;
	reg		[31:0]	LOC_ADDR	;
	reg		[7:0]	LOC_WD		;
	reg				LOC_WE		;
	reg				LOC_RE		;
	wire			LOC_ACK		;
	wire	[7:0]	LOC_RD		;

	initial begin
		LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		wait(resetSw==1'b1);

		repeat(40) @(posedge DLY_CLK);

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 1;	LOC_WD = 8'h12;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 1;	LOC_WD = 8'h0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

/*
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 1;	LOC_WD = 8'h1;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 2;	LOC_WD = 8'h2;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 3;	LOC_WD = 8'h3;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 4;	LOC_WD = 8'h4;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 5;	LOC_WD = 8'h5;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 6;	LOC_WD = 8'h6;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 7;	LOC_WD = 8'h7;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 8;	LOC_WD = 8'h8;	LOC_WE = 1;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		// ***** Read *****

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 1;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 2;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 3;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 4;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 5;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 6;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 7;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;

		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 8;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 1;
		@(posedge DLY_CLK) LOC_ACT = 1;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
		wait(LOC_ACK==1'b1);
		@(posedge DLY_CLK) LOC_ACT = 0;	LOC_ADDR = 0;	LOC_WD = 0;	LOC_WE = 0;	LOC_RE = 0;
*/
		repeat(300) @(posedge DLY_CLK);
		$finish;
	end

//------------------------------------------------------------------------------
//	Clock generator
//------------------------------------------------------------------------------
	reg			CLK			;

	parameter	CLK_PERIOD	= 20;

	initial begin
		CLK	= 1'b0;
	end

	always #(CLK_PERIOD/2) begin
		CLK	<= ~CLK;
	end

	assign	#1 DLY_CLK	= CLK;

//------------------------------------------------------------------------------
//	Reset 
//------------------------------------------------------------------------------
	initial begin
		resetSw	= 0;
		repeat(10) @(posedge DLY_CLK);
		resetSw	= 1;
	end

//------------------------------------------------------------------------------
//	DUT
//------------------------------------------------------------------------------
	reg		[3:0]	timer;

	always@ (posedge CLK or negedge resetSw) begin
		if(~resetSw)begin
			timer[3:0]	<= 4'd0;
		end else begin
			timer[3:0]	<= timer[3:0] + 4'd1;
		end
	end

	wire			TIM_PULSE;

	assign	TIM_PULSE = (timer[1:0]==2'b11);


	SIO_MASTER			SIO_MASTER(
		// System
		.CLK					(CLK			),	// in	: System clock
		.RSTn					(resetSw		),	// in	: System reset
		// Timer
		.TIM_1US				(TIM_PULSE		),	// in	: 1us interrupt
		.ADDR_WIDTH				(2'd0			),	// in	: Address width[1:0]
													//		   0: 8bit, 1:16bit, 2:24bit, 3:32bit
		// SiTCP I/F
		.LOC_ACT				(LOC_ACT		),	// in	: Request
		.LOC_ADDR				(LOC_ADDR[31:0]	),	// in	: Address[31:0]
		.LOC_WD					(LOC_WD[7:0]	),	// in	: Data[7:0]
		.LOC_WE					(LOC_WE			),	// in	: Write enable
		.LOC_RE					(LOC_RE			),	// in	: Read enable
		.LOC_ACK				(LOC_ACK		),	// out	: Access acknowledge
		.LOC_RD					(LOC_RD[7:0]	),	// out	: Read data[7:0]
		// Serial I/F
		.SCK					(REG_CLK		),	// out	: Clock
		.SCS					(REG_ACT		),	// out	: Active
		.SI						(REG_DI			),	// in	: Data input
		.SO						(REG_DO			)	// out	: Data output
	);

	wire	[31:0]	REG_ADDR		;
	wire	[7:0]	REG_WD			;
	wire	[7:0]	REG_RD			;

	SIO_SLAVE			SIO_SLAVE(
		.RSTn					(resetSw		),	// in	: System reset
		.FILL_ADDR				(32'h0000_0000	),	// in	: Filled address for narow address-width
		// Serial I/F
		.SCK					(REG_CLK		),	// in	: Clock
		.SCS					(REG_ACT		),	// in	: Active
		.SI						(REG_DI			),	// out	: Data input
		.SO						(REG_DO			),	// in	: Data output
		// Register I/F
		.REG_ADDR				(REG_ADDR[31:0]	),	// out	: Address[31:0]
		.REG_WD					(REG_WD[7:0]	),	// out	: Data[7:0]
		.REG_WE					(REG_WE			),	// out	: Write enable
		.REG_RE					(REG_RE			),	// out	: Read enable
		.REG_ACK				(REG_ACK		),	// in	: Access acknowledge
		.REG_RV					(REG_RV			),	// in	: Read valid
		.REG_RD					(REG_RD[7:0]	)	// in	: Read data[7:0]
	);

	SIO_REG				SIO_REG(
		.SCK					(REG_CLK		),	// in	: Clock
		.RSTn					(resetSw		),	// in	: System reset
		// Register I/F
		.REG_ADDR				(REG_ADDR[31:0]	),	// in	: Address[31:0]
		.REG_WD					(REG_WD[7:0]	),	// in	: Data[7:0]
		.REG_WE					(REG_WE			),	// in	: Write enable
		.REG_RE					(REG_RE			),	// in	: Read enable
		.REG_ACK				(REG_ACK		),	// out	: Access acknowledge
		.REG_RV					(REG_RV			),	// out	: Read valid
		.REG_RD					(REG_RD[7:0]	)	// out	: Read data[7:0]
	);

//------------------------------------------------------------------------------
endmodule
